using System;
using System.Collections;

namespace DesignPatterns.Observer.CSharp.WeatherData
{
	public class StatisticsDisplay
	{
		public StatisticsDisplay()
		{}

		public string GetUpdatedMeasurements(Hashtable measurements, object measurementKey)
		{
			switch(measurementKey.ToString())
			{
				case "temperature":
					return "Current temperature is: " + 
						RoundFloatToString((float)Convert.ToInt32(measurements["temperature"]));
				case "humidity":
					return "Current humidity is: " + 
						RoundFloatToString((float)Convert.ToInt32(measurements["humidity"]))+ "%";
				case "pressure":
					return "Current barometric pressure is: " + 
						RoundFloatToString((float)Convert.ToInt32(measurements["pressure"]));
				default:
					return null;
			}
		}

		#region RoundFloatToString
		public static string RoundFloatToString(float floatToRound)
		{
			System.Globalization.CultureInfo cultureInfo = new System.Globalization.CultureInfo("en-US");
			cultureInfo.NumberFormat.CurrencyDecimalDigits = 2;
			cultureInfo.NumberFormat.CurrencyDecimalSeparator = ".";
			return floatToRound.ToString("F",cultureInfo);
		}
		#endregion//RoundFloatToString

	}
}
