using System;
using System.Collections;

namespace DesignPatterns.Observer.CSharp.WeatherData
{
	public class WeatherData
	{
		private Hashtable weatherItems	= new Hashtable();

		public WeatherData(float temperature, float humidity,
			float pressure)
		{
			weatherItems.Add("temperature", temperature);
			weatherItems.Add("humidity", humidity);
			weatherItems.Add("pressure", pressure);
		}

		public delegate string GetMeasurementsDelegateHandler(Hashtable measurements, object measurementKey);
		public event GetMeasurementsDelegateHandler GetUpdatedMeasurements;

		public object Temperature
		{
			get
			{
				if(this.weatherItems["temperature"] != null)
				{
					return GetUpdatedMeasurements(weatherItems, "temperature");
				}

				return null;
			}
		}

		public object Humidity
		{
			get
			{
				if(this.weatherItems["humidity"] != null)
				{
					return GetUpdatedMeasurements(weatherItems, "humidity");
				}

				return null;
			}
		}

		public object Pressure
		{
			get
			{
				if(this.weatherItems["pressure"] != null)
				{
					return GetUpdatedMeasurements(weatherItems, "pressure");
				}

				return null;
			}
		}
	}
}
