using WeatherDataImp = DesignPatterns.Observer.CSharp.WeatherData;
using NUnit.Framework;

namespace Test.DesignPatterns.Observer.CSharp.WeatherData
{
	[TestFixture]
	public class ObserverCSharpStatisticsDisplayFixture
	{
		#region Members
		WeatherDataImp.WeatherData weatherData;
		WeatherDataImp.StatisticsDisplay statisticsDisplay;
		WeatherDataImp.WeatherData.GetMeasurementsDelegateHandler weatherDelegate;
		#endregion//Members

		#region TestFixtureSetUp Init()
		[TestFixtureSetUp]
		public void Init()
		{
			weatherData = new WeatherDataImp.WeatherData(65.2f,80.5f, 32.3f);
			statisticsDisplay = new WeatherDataImp.StatisticsDisplay();

            //ͨίдżϵĹ
    		weatherDelegate = new WeatherDataImp.WeatherData.GetMeasurementsDelegateHandler(statisticsDisplay.GetUpdatedMeasurements);
			weatherData.GetUpdatedMeasurements += weatherDelegate;
		}
		#endregion// TestFixtureSetUp Init()

		#region TestFixtureTearDown Dispose()
		[TestFixtureTearDown]
		public void Dispose()
		{
			weatherData = null;
			statisticsDisplay = null;
			weatherData = null;
		}
		#endregion//TestFixtureTearDown Dispose()

		#region TestStatisticsDisplay
		[Test]
		public void TestStatisticsDisplay()
		{
			Assert.AreEqual("Current temperature is: 65.00",
				weatherData.Temperature);
			Assert.AreEqual("Current humidity is: 80.00%",
				weatherData.Humidity);
			Assert.AreEqual("Current barometric pressure is: 32.00",
				weatherData.Pressure);
		}
		#endregion//TestStatisticsDisplay
	}
}
